/****************************************/
/*  Class to resolve hostnames		*/
/****************************************/
/* Start      : 03/08/2001		*/
/* Program ID : 			*/
/* Version    : 2.00			*/
/* End        : 			*/
/* Last Update: 03/08/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#include "vresolv2.h"
#include "v/mem/vtable.cc"

int VRESOLV::usetcp=0;

VRESOLV::VRESOLV()
{
	names=ips=0;
}

VRESOLV::~VRESOLV()
{
}

VRESOLV::VRESOLV(VRESOLV &d)
{
	ddd(d);
}

VRESOLV VRESOLV::operator=(VRESOLV &d)
{
	clear();
	ddd(d);
	return (*this);
}

void VRESOLV::ddd(VRESOLV &d)
{
	name=d.name;
	ip=d.ip;
	names=d.names;
	ips=d.ips;
}

void	VRESOLV::operator=(IPLONG ip)
{
	do_reverse(ip);
}

void	VRESOLV::operator=(const char *p)
{
	in_addr		inaddr;
	int		ret;

	if (p==NULL) return;

	ret=inet_aton(p,&inaddr);
	if (ret==0)	// not a DDN ip address
	{
		do_resolve(p);
	} else
	{
		this->operator=(inaddr.s_addr);
	}
}

void	VRESOLV::operator=(const LONGLINE& p)
{
	this->operator=(p.p);
}

void	VRESOLV::operator=(const IPADDR &ip)
{
	this->operator=(ip.ipaddr.s_addr);
}

void	VRESOLV::do_reverse(IPLONG ip)
{
	hostent		*h;

	clear();
	this->ip[0]=ntohl(ip);
	ips=1;
	h=gethostbyaddr((char *)&ip,sizeof(IPLONG),AF_INET);

	setdata(h);
}

void	VRESOLV::do_resolve(const char *p)
{
	hostent		*h;

	clear();
	name[0]=p;
	names=1;
	h=gethostbyname(p);
	setdata(h);
}

void	VRESOLV::setdata(hostent *h)
{
	char		*p;
	int 		n;
	in_addr		inaddr;

	if (h!=NULL)
	{
		name[0]=h->h_name;
		p=h->h_aliases[0];
		n=0;
		while ((p=h->h_aliases[n])!=NULL)
		{
			name[n+1]=p;
			n++;
		}
		names=n+1;

		n=0;
		while((p=h->h_addr_list[n])!=NULL)
		{
			inaddr.s_addr=*(long *)p;
			ip[n]=inaddr;
			n++;
		}
		ips=n;
		error=0;
	} else
	{
		error=h_errno;
	}
}

void VRESOLV::dump()
{
	int		n;
	LONGLINE	ll;

	printf("VRESOLV:\n");
	printf("	Hostname: %s\n",name[0].p);
	ll="";
	for (n=1;n<names;n++)
	{
		ll+=name[n];
		ll+=", ";
	}
	ll--;ll--;
	printf("	Aliases: %s\n",ll.p);
	ll="";
	for (n=0;n<ips;n++)
	{
		ll+=ip[n].hostname;
		ll+=", ";
	}
	ll--;ll--;
	printf("	IPs: %s\n",ll.p);
}

void	VRESOLV::clear()
{
	name.Clear();
	names=0;
	ip.Clear();
	ips=0;
}

VRESOLV::operator LONGLINE()
{
	LONGLINE	ll="";

	if (names)
		ll=name[0];

	return(ll);
}

VRESOLV::operator IPLONG()
{
	IPLONG	ret=0xFFFFFFFF;

	if (ips)
		ret=ip[0].ipaddr.s_addr;

	return(ret);
}

LONGLINE VRESOLV::ipaddr()
{
	LONGLINE	ll="";

	if (ips)
	{
		ll=inet_ntoa(ip[0].ipaddr);
	}

	return(ll);
}

void VRESOLV::useTCP(int usetcp)
{
	if (usetcp==this->usetcp)	// no change
		return;

	this->usetcp=usetcp;
	if (usetcp==1)
	{
		sethostent(1);
	} else
	{
		endhostent();
	}
}
