/****************************************/
/*  FILEBASE class                      */
/****************************************/
/* Start      : 27/5/98                 */
/* Program ID :                         */
/* Version    : 1.01                    */
/* End        :                         */
/* Last Update: 28/08/2001              */
/* Comments   :                         */
/*                                      */
/****************************************/

#include "filebase.h"

FILEBASE::FILEBASE()
{
 fp=NULL;
}

FILEBASE::~FILEBASE()
{
/* if (fp!=NULL)
  Close(fp);*/
}

FILEBASE::FILEBASE(const FILEBASE& p)
{
 vvv(p);
}

void FILEBASE::vvv(const FILEBASE& p)
{
 fp=p.fp;
}

FILEBASE FILEBASE::operator=(const FILEBASE &p)
{
 // fp=dup(p.fp);
 // FILEBASE::FILEBASE(p);
 // this->FILEBASE(p);
 vvv(p);
 return(*this);
}

int FILEBASE::Exist(const char *name)
{
 struct stat s;
 return (!stat(name,&s));
}

FILE *FILEBASE::Fopen(const char *name, char *mode)
{
 FILE *f;
 f=fopen(name,mode);

 fp=f;
 return(f);
}

FILE *FILEBASE::Open(const char *name)
{
 FILE *f;
 
 if (Exist(name))
  f=Fopen(name,"r+b");
 else
  f=Create(name);

 if (f==NULL)
  Handler(errno);
 
 fp=f;
 return(f);
}

FILE *FILEBASE::OpenNoCreate(const char *name)
{
 FILE *f;
 f=NULL;
 
 if (Exist(name))
 {
  f=Fopen(name,"r+b");
  if (f==NULL)
   Handler(errno);
 }

 fp=f;
 return(f);
}

FILE *FILEBASE::OpenRead(const char *name)
{
 FILE *f;
 f=NULL;
 
 if (Exist(name))
 {
  f=Fopen(name,"rb");
  if (f==NULL)
   Handler(errno);
 }

 fp=f;
 return(f);
}


FILE *FILEBASE::Create(const char *name)
{
 FILE *f;
 f=Fopen(name,"w+b");
 
 if (f==NULL)
  Handler(errno);

 fp=f;
 return(f);
}

void FILEBASE::Close() { Close(fp); fp=NULL;}
void FILEBASE::Close(FILE *f) { if (f!=NULL) {fclose(f);} }

void FILEBASE::Rewind() { Rewind(fp);}
void FILEBASE::Rewind(FILE *f) { if (f!=NULL) {rewind(f);} }

void FILEBASE::Seekend() { Seekend(fp); }
void FILEBASE::Seekend(FILE *f) { if (f!=NULL) {fseek(f,0L,SEEK_END);} }


size_t FILEBASE::Read(void *ptr, size_t size)
{
 return(Read(ptr,size,1,fp));
}
size_t FILEBASE::Read(void *ptr, size_t size, size_t nmemb)
{
 return(Read(ptr,size,nmemb,fp));
}
size_t FILEBASE::Read(void *ptr, size_t size, size_t nmemb, FILE *f)
{
 size_t n;

 if (fp==NULL) return(0);
 
 n=fread(ptr,size,nmemb,f);
 Handler(ferror(f));
 
 return(n);
}

size_t FILEBASE::Fgets(char *s, int size, FILE *f)
{
 size_t l;
 char *st;
 l=0;

 if (f==NULL) return(0);

 // l=fread(s,size,1,f);
 // l=fgets(s,size,f);
 *s=0;
 st=fgets(s,size,f);
 if (st!=NULL)
 {
  l=strlen(st);
  if ((l==0) && (!feof(f)))
  Handler(ferror(f));
 }
 return(l);
}

size_t FILEBASE::Fgets(char *s, int size)
{
 return(Fgets(s,size,fp));
}

size_t FILEBASE::Write(void *ptr, size_t size)
{
 return(Write(ptr,size,1,fp));
}
size_t FILEBASE::Write(void *ptr, size_t size, size_t nmemb)
{
 return(Write(ptr,size,nmemb,fp));
}
size_t FILEBASE::Write(void *ptr, size_t size, size_t nmemb, FILE *f)
{
 size_t n;
 
 if (f==NULL) return(0);
 n=fwrite(ptr,size,nmemb,f);
 Handler(ferror(f));

 return(n);
}


int FILEBASE::Seek(long n) { return(Seek(fp,n,SEEK_SET)); }
int FILEBASE::Seek(long n, int whence) { return(Seek(fp,n,whence)); }
int FILEBASE::Seek(FILE *f, long n) { return(Seek(f,n,SEEK_SET)); }
int FILEBASE::Seek(FILE *f, long l, int whence)
{
 int n;

 if (f==NULL) return(-1);

 n=fseek(f,l,whence);
 if (!n)
  Handler(errno);

 return(n);
}

void FILEBASE::Move(long n) { Move(fp,n); }
void FILEBASE::Move(FILE *f, long n) { Seek(f,n,SEEK_CUR); }

long FILEBASE::GetPos() { return(GetPos(fp)); }
long FILEBASE::GetPos(FILE *f) { if (f!=NULL) { return(ftell(f)); } else { return -1; }}

void FILEBASE::SetPos(long l) { SetPos(fp,l); }
void FILEBASE::SetPos(FILE *f, long l) { Seek(f,l); }

int FILEBASE::Feof() { if (fp!=NULL) return(feof(fp)); else return (1);}

