/****************************************/
/*  FILEBASE class (header)             */
/****************************************/
/* Start      : 27/5/98                 */
/* Program ID :                         */
/* Version    : 1.01                    */
/* End        :                         */
/* Last Update: 28/10/98                */
/* Comments   :                         */
/*                                      */
/****************************************/

/*
 1.01: feof() changed with Feof()
       Checking for f==NULL when Close is called
       Added OpenRead()
 */

#ifndef _VLIB_V_FILE_FILEBASE_H
#define _VLIB_V_FILE_FILEBASE_H

#include "v/verror.h"
#include "sys/stat.h"
#include "stdio.h"
#include "unistd.h"
#include "string.h"

class FILEBASE : public ERROR
{
 private:
 protected:
 public:
  FILE *fp;
 private:
  void vvv(const FILEBASE& p);
 protected:
  int Exist(const char *name);
  FILE *Fopen(const char *name, char *mode);
 public:
  FILEBASE();
  ~FILEBASE();
  FILEBASE(const FILEBASE& p);
  FILEBASE operator=(const FILEBASE &p);
  FILE *Open(const char *name);
  FILE *OpenNoCreate(const char *name);
  FILE *OpenRead(const char *name);
  void Close();
  void Close(FILE *f);
  FILE *Create(const char *name);

  void Rewind();
  void Rewind(FILE *f);

  void Seekend();
  void Seekend(FILE *f);

  size_t Read(void *ptr, size_t size);
  size_t Read(void *ptr, size_t size, size_t nmemb);
  size_t Read(void *ptr, size_t size, size_t nmemb, FILE *f);

  size_t Fgets(char *s, int size, FILE *f);
  size_t Fgets(char *s, int size);

  size_t Write(void *ptr, size_t size);
  size_t Write(void *ptr, size_t size, size_t nmemb);
  size_t Write(void *ptr, size_t size, size_t nmemb, FILE *f);

  int Seek(long n);
  int Seek(long n, int whence);
  int Seek(FILE *f, long n);
  int Seek(FILE *f, long n, int whence);

  void Move(long n);
  void Move(FILE *f, long n);

  long GetPos();
  long GetPos(FILE *f);

  void SetPos(long l);
  void SetPos(FILE *f, long l);

  int Feof();
};
#endif
