/****************************************/
/*					*/
/****************************************/
/* Start      : 09/09/2002		*/
/* Version    : 1.00			*/
/* Last Update: 09/09/2002		*/
/****************************************/

#include "filebuf.h"
#include "unistd.h"

#define BUFFER_SIZE	8190
#define	WRITE_BLOCK	8190

FILEBUF::FILEBUF()
{
	WaitRead=1;
	WaitWrite=0;
}

FILEBUF::~FILEBUF()
{
}

int	FILEBUF::doRead()
{
	ssize_t		len;
	char		buf[BUFFER_SIZE+1];
	int		ret=0;

	len=read(fd,buf,BUFFER_SIZE);
	if (len<=0)	// Error
	{
		Reject();
		return(-1);
	}

	in.Push(buf,len); // store it in the queue

	ret=OnRead();

	if (ret==-1)
	{
		in.Clear();
		out.Clear();
	}

	return(ret);
}

int	FILEBUF::doWrite()
{
	size_t		len;
	char		buf[WRITE_BLOCK+1];
	int		ret=0;

	len=out.PopNoErase(buf,WRITE_BLOCK);	// get max WRITE_BLOCK data
	len=write(fd,buf,len);			// try to send them

	if (len>0)
		out.Discard(len);	// remove those send

	if (out.Size()==0)
		WaitWrite=0;		// If we are done, then we don't want to write any more

	if (len<=0)
	{
		Reject();
		ret=-1;
	}

	return(ret);
}

int	FILEBUF::doExcept()
{
	Reject();
	return(-1);
}

void	FILEBUF::Reject()
{
	OnError();

	close(fd);

	in.Clear();
	out.Clear();

	WaitRead=0;
	WaitWrite=0;
	WaitConnect=0;
}

void	FILEBUF::Write(const char *buf, size_t len)
{
	out.Push(buf,len);	// and the data
	WaitWrite=1;		// set the write flag
}

int	FILEBUF::OnRead()
{
	return(0);
}

void	FILEBUF::OnError()
{
}

