/****************************************/
/*					*/
/****************************************/
/* Start      : 09/09/2002		*/
/* Version    : 1.00			*/
/* Last Update: 09/09/2002		*/
/****************************************/

#ifndef _VLIB_V_FILE_FILEBUF_H
#define _VLIB_V_FILE_FILEBUF_H

#include "selector.h"

#include "v/mem/bytequeue.h"

class FILEBUF : public SELECTOR_BASE_ONE
{
 private:
 protected:
        ByteQueue               in,out;
 public:
 private:
 protected:
	void		Reject		();

	virtual int 	OnRead		();	// call this when data came	// Return: 0: Ok, -1: Close the connection
						// OnError WILL NOT be called when OnRead returns -1
	virtual void	OnError		();	// call this when error occured
						// fd will be auto-closed and buffers will be cleared AFTER OnError() returns
 public:
		FILEBUF		();
	virtual ~FILEBUF	();

	int	doRead		();
	int	doWrite		();
	int	doExcept	();

	void	Write		(const char *buf, size_t len);	// write data
};


#endif

