/****************************************/
/*					*/
/****************************************/
/* Start      : 22/09/2002		*/
/* Version    : 1.00			*/
/* Last Update: 22/09/2002		*/
/****************************************/

#include "filebuf_line.h"

#include "v/mem/dlist3.cc"

FILEBUF_LINE::FILEBUF_LINE()
{
	maxline=0;
}

FILEBUF_LINE::~FILEBUF_LINE()
{
}

int FILEBUF_LINE::OnLine(const char *line)
{
	return(0);
}

void FILEBUF_LINE::OnReject()
{
}

void FILEBUF_LINE::OnError()
{
	if (in.Size()>0)
	{
		do_check(1);
	}
	OnReject();
}

int FILEBUF_LINE::OnRead()
{
	int	ret;

	ret=do_check();

	return(ret);
}

int	FILEBUF_LINE::do_check(int islast)
{
	int	ret;
	int	n;

	do {
		n=get_line(islast);
	} while (n);

	ret=check_lines();

	if ((n<0) && (!islast))	// if there was an error and it is not called from OnError()
	{
		OnReject();
		ret=-1;
	}

	return(ret);
}

/*
	Get another line if available
	return: 1: got a line
		0: No line was available
		-1: Error - line too long
*/
int	FILEBUF_LINE::get_line(int islast)
{
	int		ret=0;
	char		buf[1025];
	int		OK=0;
	long		n;
	char		*p;
	LONGLINE	ll;

	buf[1024]=0;
	ll="";

	while (!OK)	// find the first new line (if any)
	{
		n=in.Pop(buf,1024);	// try to get 1024 more bytes
		if (!n)	// no more bytes
		{
			if (!islast)
			{
				OK=-1;
				if (ll.len)
					in.UnPop(ll.p,ll.len);	// put those back
			} else
			{
				inlines.PushL(ll);
				OK=1;
				ll="";
				ret=0;	// this is the last line
			}
		} else
		{
			buf[n]=0;
			p=strchr(buf,'\n');		// search for a new line
			if (p!=NULL)	// got it!
			{
				*p=0;
				if ((p>buf) && (*(p-1)=='\r'))
					*(p-1)=0;	// also clear \r (if there is one before \n)
				if (buf[0]=='\r')	// ignore the first char if it is a \r
					ll+=buf+1;
				else
					ll+=buf;
				n-=(p-buf)+1;
				if (n) in.UnPop(p+1,n);	// put the rest back
				OK=1;
				inlines.PushL(ll);	// store this one
				ll="";			// clear the buffer
				ret=1;
			} else
			{
				ll+=buf;
				if (maxline!=0)
				{
					if (maxline>0)
					{
						if (ll.len>=(size_t)maxline)
						{
							int	m;

							OK=1;
							ret=1;
							inlines.PushL(ll);
							ret=1;

							n=in.PopNoErase(buf,2);	// If there is a new line immediately after this buffer
										// then remove it
							if (n)
							{
								m=0;
								if (buf[0]=='\r' || buf[0]=='\n')
								{
									m=1;
									if ((n==2) && ((buf[1]=='\r') || (buf[1]=='\n')))
										m=2;
								}
								if (m)
									in.Discard(m);
							}
						}
					} else
					{
						if (ll.len >= (size_t)(-1*maxline))
						{
							OK=-1;
							ret=-1;
							ll="";
						}
					}
				}
			}
		}
	}

	return(ret);
}

int	FILEBUF_LINE::check_lines()
{
	LONGLINE	*pll;
	int		ret;

	inlines.Rewind();

	while ((pll=inlines.Pop())!=NULL)
	{
		ret=OnLine(pll->p);
		if (ret)
			return(ret);
	}

	return(0);
}

void	FILEBUF_LINE::Write(const char *line)
{
	FILEBUF::Write(line, strlen(line));
}

