/****************************************/
/*  Various simple file tasks		*/
/****************************************/
/* Start      : 10/11/2001		*/
/* Program ID : 			*/
/* Version    : 1.01			*/
/* End        : 			*/
/* Last Update: 09/02/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_FILE_FILEOPS_H
#define _VLIB_V_FILE_FILEOPS_H

#define	FILE_IS_REG	1	// regular file
#define FILE_IS_DIR	2	// directory
#define FILE_IS_CHAR	3	// character device
#define FILE_IS_BLOCK	4	// block device
#define FILE_IS_FIFO	5	// fifo
#define FILE_IS_MISC	10	// other type (socket/link)

#include "v/mem/longline.h"

#include "stdio.h"

/*
	Check a if file exists
	Return:
		0: doesn't exist, or it is not accessible
		>0 : it exists. its type is returned (see FILE_IS_*)
*/
int	file_exist(const char *fn);

LONGLINE fgetline(FILE *f);	// Read the next line from f
				// Return "" on error AND on empty lines
				// will chop CRLFs

void	set_block(int fd, int block);	// set fd to blocking/non-blocking mode
					// block == 0 -> Non-blocking
					// block == 1 -> blocking

#endif

