/****************************************/
/*  Session management for cgi's        */
/****************************************/
/* Start      : 15/12/99                */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 15/12/99                */
/* Comments   :                         */
/*                                      */
/****************************************/

#include "v/misc/keytable2.cc"

#include "session.h"
#include "unistd.h"	// for now..

Session::Session(char *Path, char *Domain)
{
	time_t t;

	found=-1;
	if (Path)
		this->Path=strdup(Path);
	else
		this->Path=NULL;

	if (Domain)
		this->Domain=strdup(Domain);
	else
		this->Domain=NULL;

	t=time(NULL);
	srandom(t);
}

Session::~Session()
{
	free(Path);
	free(Domain);
}

void Session::Generate()
{
	long l;
	time_t t;
	pid_t	p;
	RANDOM	r;

	t=time(NULL);
	l=r;
	p=getpid();
	sprintf(Value,"%08X%08X%08X%04X",(u_int)info.ip,(u_int)t,(u_int)l,p);
}

int Session::Validate(char *st2)
{
	char tmp[101];
	char *st;

	if (st2==NULL) st=Value;
	else st=st2;

	if (strlen(st)<8) return(0);
	tmp[100]=0;
	sprintf(tmp,"%08X",(u_int)info.ip);
	if (strncmp(tmp,st,8)) return(0);


	return(1);
}

void Session::SetCookie(CGI *cgi)
{
	LONGLINE l;

/*	l=SESSION_COOKIE;
	l+="=";
	l+=Value;
	l+="; Version=1";
	if (Path!=NULL)
	{
		l+="; Path=";
		l+=Path;
	}
	if (Domain!=NULL)
	{
		l+="; Domain=";
		l+=Domain;
	}
	l+="; Max-Age=";
	l+=MAX_AGE;
	cgiSetHeader("Set-Cookie",l.p);*/
	cgi->set_cookie(SESSION_COOKIE,Value,Domain,MAX_AGE,Path);
}

void Session::GetCookie()
{
	LONGLINE *p;

	p=info.cookies[SESSION_COOKIE];
	if (!p) found=0;
	else
	{
		found=1;
		strncpy(Value,p->p,127);
		Value[127]=0;
	}
}

void Session::CreateSession()
{
//	char st[1024];
	
//	sprintf(st,"/bin/echo CreateSession %s > /dev/console",Value);
//	system(st);
}

void Session::GetSession()
{
//	char st[1024];
	
//	sprintf(st,"/bin/echo GetSession %s > /dev/console",Value);
//	system(st);
}
