/****************************************/
/*  Message Queues			*/
/****************************************/
/* Start      : 22/08/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 22/08/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_IPC_MQUEUE_H
#define _VLIB_V_IPC_MQUEUE_H

#include "errno.h"
#include "stdlib.h"
#include "string.h"
#include "sys/types.h"
#include "sys/ipc.h"

#define MQUEUE_KEY_UNIQUE	(key_t)-2
#define MQUEUE_KEY_PRIVATE	IPC_PRIVATE

/*
	NOTE: You must destroy the message queue manualy, using MQUEUE::destroy()
*/

class MQUEUE
{
 private:
 	key_t	mkey;
	int	msgid;
	int	autocreate;
 public:
 private:
	void	ddd		(MQUEUE &d);
	void	create		();
	int	check		();	// return 1: if the msgqueue is funcitonal, or 0: if it is not.. (unavailable)
 public:
		MQUEUE		(key_t tkey=MQUEUE_KEY_UNIQUE, int autocreate=1);
		~MQUEUE		();
		MQUEUE		(MQUEUE &d);
	MQUEUE	operator=	(MQUEUE &d);
	int	key		();	// return the key
	void	push		(long type, void *buf, size_t len);
	void	*pop		(long type, size_t len, int block=0);	// pop a message of type type. with size len, or NULL if not found
	void	*pop		(size_t len, int block=0);
	void	destroy		();
};

#endif

