/****************************************/
/*					*/
/****************************************/
/* Start      : 08/09/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 08/09/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#include "shm.h"
#include "sys/ipc.h"
#include "sys/shm.h"
#include "stdlib.h"
#include "string.h"
#include "v/lconfig.h"

#define KEY_BASE	100
#define PERM		0700

SHM::SHM(size_t size, key_t tkey)
{
	skey=tkey;
	shmid=-1;
	this->shmsize=size;
	p=NULL;

	create();
	attach();
}

SHM::~SHM()
{
	detach();
}

SHM::SHM(SHM &d)
{
	ddd(d);
}

SHM SHM::operator=(SHM &d)
{
	detach();
	ddd(d);
	return (*this);
}

void SHM::ddd(SHM &d)
{
	skey=d.skey;
	shmsize=d.shmsize;
	shmid=-1;
	create();
	attach();
}

void	SHM::create()
{
	key_t	k;

	switch(skey)
	{
		case SHM_KEY_UNIQUE:
			k=KEY_BASE-1;
			do {
				k++;
				shmid=shmget(k,shmsize,IPC_CREAT | IPC_EXCL | PERM);
			} while (shmid<0);
			skey=k;
			break;
		case SHM_KEY_PRIVATE:
			skey=IPC_PRIVATE;
			shmid=shmget(skey,shmsize,PERM);
			break;
		default:
			shmid=shmget(skey,shmsize,0);
			if (shmid==-1)
			{
				shmid=shmget(skey,shmsize,IPC_CREAT | PERM);
			}
			break;
	}
}

void	SHM::destroy()
{
	int	ret;

	if (shmid!=-1)
	{
		ret=shmctl(shmid,IPC_RMID,NULL);
		shmid=-1;
	}
}

void	SHM::attach()
{
	detach();
	p=shmat(shmid,0,0);
}

void	SHM::detach()
{
	if (p!=NULL)
	{
#ifdef SHMDT_CHAR_P
		shmdt((char *)p);
#else
		shmdt(p);
#endif
	}
}

key_t	SHM::key()
{
	return(skey);
}

void	*SHM::get_data()
{
	void	*p=NULL;

	if (this->p!=NULL)
	{
		p=malloc(shmsize);
		memcpy(p,this->p,shmsize);
	}

	return(p);
}

size_t	SHM::size()
{
	return(shmsize);
}

int	SHM::check()
{
	int		ret;
	int		done;
	shmid_ds	buf;

	if (shmid==-1) ret=0;
	else
	{
		do {
			done=1;
			ret=shmctl(shmid,IPC_STAT,&buf);
			if (ret==-1) ret=0;	// error
			else ret=1;
		} while (!done);
	}

	return(ret);
}

int	SHM::get_attachn()
{
	int		ret;
	shmid_ds	buf;

	if (shmid==-1) ret=0;
	else
	{
		ret=shmctl(shmid,IPC_STAT,&buf);
		if (ret==-1) ret=0;
		else ret=(int)buf.shm_nattch;
	}

	return(ret);
}
