/****************************************/
/*					*/
/****************************************/
/* Start      : 31/08/2002		*/
/* Version    : 1.00			*/
/* Last Update: 31/08/2002		*/
/****************************************/

#ifndef _VLIB_V_MEM_FIXEDELEMENTLIST_H
#define _VLIB_V_MEM_FIXEDELEMENTLIST_H

/*
	A list that holds simple elements of fixed size.
	Elements must be able to be memcpy()ied and memmove()ed.
*/

#include "sys/types.h"

template<class T> class FixedElementList
{
 private:
	size_t		size;	// Size in elements
	size_t		bs;	// Block size in elements
	T		*buf;
	size_t		pos;	// For Rewind/Get_Next
	int		unique;
 public:
	size_t		count;	// Number of available elements
 private:
	void			vvv		(FixedElementList& p);
	inline void		SetSize		(size_t elements);	// Set the size to hold at least elements
 public:
				FixedElementList	();
				~FixedElementList	();
				FixedElementList	(FixedElementList &p);
	FixedElementList	operator=		(FixedElementList& p);

	T		operator[]	(size_t l);	// Return the element with seq#==l -- undefined if out of range
	T		Get		(size_t l);	// Return the element with seq#==l -- undefined if out of range
	void		Add		(T l);		// Add element
	void		Del		(T l);		// Remove element
	void		DelIndex	(size_t idx);	// Remove element with seq#==l
	int		Exist		(T l);		// Return 1 if it exists, 0 if not
	long		Index		(T l);		// Find the element and return the seq# (else return -1)
	void		Set		(size_t idx, T l);	// Set an existing value
	void		Clear		();
	void		Rewind		();
	T		*Get_Next	();
	void		SetUnique	(int n);	// if the elements must be unique or not
							// Setting this will remove duplicate ellements
};


#endif

