/****************************************/
/*  MEMPOOL class (header)              */
/****************************************/
/* Start      : 17/5/99                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 17/5/99                 */
/* Comments   : Pool of same objects    */
/*                                      */
/****************************************/

/*
 MEMPOOL<OBJECT_TYPE> mpla

 mpla.Init(100); Allocate memory for 100 Objects
 
 */

#ifndef _VLIB_V_MEM_MEMPOOL_H
#define _VLIB_V_MEM_MEMPOOL_H

#include "v/mem/dlist3.h"

//#include "malloc.h"
#include "stdlib.h"

class MEM_SECTOR
{
 private:
 public:
  long uses; // Number of times this object is Set'd (Allocated?)
  void *p;
 private:
  void ddd(MEM_SECTOR &d);
 public:
  MEM_SECTOR();
  ~MEM_SECTOR();
  MEM_SECTOR(MEM_SECTOR &d);
  MEM_SECTOR operator=(MEM_SECTOR &d);
};

template <class T> class MEMPOOL
{
 private:
  DL_List<MEM_SECTOR> pointers;   // Pointers to allocated memory
  DL_List<MEM_SECTOR> dUsed,dFree;
  long UsedN,FreeN;
 public:
  long Segment; // Increament size, after the initial allaocated memory is exausted
 private:
  void ddd(MEMPOOL<T> &p);
  void Allocate(long l); // Allocate memory for l more objects
 public:
  MEMPOOL();
  ~MEMPOOL();
  MEMPOOL(MEMPOOL<T> &p);
  MEMPOOL<T> operator=(MEMPOOL<T> &p);
  void Init(long l); // l= Initial number of objects preallocated
  T *Get();
  void Free(T *p);
  void Show_Stats();
};

#endif
