/****************************************/
/*  Small Queue (header)                */
/****************************************/
/* Start      : 31/8/97                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 31/8/97                 */
/* Comments   : Limited size stack      */
/*                                      */
/****************************************/


#ifndef _VLIB_V_MEM_SMALLQ_H
#define _VLIB_V_MEM_SMALLQ_H

#include "dlist3.h"

#define _SMALLQ_DEFAULT_QSIZE 100

template <class T> class SmallQ : private DL_List<T>
{
 private:
  long QSize;
 public:
 private:
 public:
  SmallQ();
  ~SmallQ();
  T *DL_List<T>::operator[](int);  // Make [] available

  void Push(T FAR *data1);
  void Push(T& FAR data1);
  void PushL(T FAR *data1);
  void PushL(T& FAR data1);

  T FAR *Pop();
  T FAR *PopL();
};

#endif

/*
 Qsize=5:

 <0> ---- <1> ---- <2> ---- <3> ---- <4>
  a        b        c        d        e

 *Push(f)=PushL(f);
 result:

 <0> ---- <1> ---- <2> ---- <3> ---- <4>
  b        c        d        e        f

 Pop()=PopL();
 result:

 <0> ---- <1> ---- <2> ---- <3> ---- <4>
  c        d        e        f      *NULL*
 
 */
