/****************************************/
/*  Tree class                          */
/****************************************/
/* Start      : 15/12/98                */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 15/12/98                */
/* Comments   :                         */
/*                                      */
/****************************************/

#ifndef _TREE_CPP
#define _TREE_CPP


#include "tree.h"
//#include "dlist2.cpp"
#include "v/misc/keytable2.cc"

template <class T> TREE<T>::TREE()
{
 moving=&Head;
// curchild=NULL;
}

template <class T> TREE<T>::TREE(T *head)
{
 moving=&Head;
 Head.Data=*head;
// curchild=NULL;
}

template <class T> TREE<T>::TREE(T &head)
{
 moving=&Head;
 Head.Data=head;
// curchild=NULL;
}

template <class T> TREE<T>::~TREE()
{
}

template <class T> void TREE<T>::Init(T &head)
{
 moving=&Head;
 Head.Data=head;
 Head.curchild=NULL;
 DelAllChilds(moving);
}

template <class T> void TREE<T>::DelAll(TREE_NODE<T> *p)
{
 DelAllChilds(p);
 Del(p);
}

template <class T> void TREE<T>::DelAllChilds(TREE_NODE<T> *p)
{
 TREE_NODE<T> **t;

 p->Next.Rewind();
 while ((t=p->Next.Get_Next())!=NULL)
 {
  DelAll(*t);
 }
 p->Next.ClearList();
}

template <class T> void TREE<T>::Del(TREE_NODE<T> *p)
{
 // delete *p;
 DelNode(p);
 Count--;
}

template <class T> TREE_NODE<T> *TREE<T>::NewNode(T *p)
{
 TREE_NODE<T> *t;
 
 t=new(TREE_NODE<T>);
 t->Data=*p;
 
 return(t);
}

template <class T> void TREE<T>::DelNode(TREE_NODE<T> *p)
{
 delete p;
}

template <class T> void TREE<T>::Append(T *Data)
{
 ApendAA(Data);
 GoBack();
}

template <class T> void TREE<T>::Append(T &Data)
{
 
 Append(&Data);
}

template <class T> void TREE<T>::AppendAA(T *Data)
{
 TREE_NODE<T> *t;

 t=NewNode(Data);
 t->Prev=moving;
 moving->Next.PushL(t);
 Count++;
 moving=t;
}

template <class T> void TREE<T>::AppendAA(T &Data)
{
 AppendAA(&Data);
}

template <class T> void TREE<T>::Delete()
{
 TREE_NODE<T> *p;

 if (moving != &Head)  // Check to see if we are on the head, se we won't erase it
 {
  p=moving->Prev;
  DelAll(moving);
 } else
 {
  p=moving;
  DelAllChilds(moving);
 }

 moving=p;
 moving->curchild=NULL;
}

template <class T> void TREE<T>::Unlink()
{
 TREE_NODE<T> *p,*t;

 if (moving!=&Head)
 {
  p=moving->Prev;
 } else
 {
  p=moving;
 }
 moving->Next.Rewind();
 while ((t=moving->Next.Get_Next())!=NULL)
 {
  t->Prev=p;
  p->Next.PushL(t);
 }
 if (moving!=&Head)
  Del(moving);

 moving=p;
 moving->curchild=NULL;
}

template <class T> void TREE<T>::DelAllChilds()
{
 DelAllChilds(moving);
 moving->curchild=NULL;
}

template <class T> void TREE<T>::cRewind()
{
 if (moving!=NULL)
 {
  moving->Next.Rewind();
 }
 moving->curchild=NULL;
}

template <class T> T *TREE<T>::cGet_Next()
{
 T *t;
 TREE_NODE<T> **tn;
 
 t=NULL;
// moving->curchild=NULL;
 if (moving!=NULL)
  if ((tn=moving->Next.Get_Next())!=NULL)
  {
   t=&(*tn)->Data;
   moving->curchild=*tn;
  }
 // return(&((curchild=*moving->Next.Get_Next())->Data));
 
 return(t);
}

template <class T> T *TREE<T>::Advance()
{
 T *p;
 
 p=NULL;
 if (moving->curchild!=NULL)
 {
  moving=moving->curchild;
  p=&moving->Data;
 }
 else moving=NULL;
  
 return(p);
}

template <class T> void TREE<T>::GoBack()
{
 if (moving->Prev!=NULL)
  moving=moving->Prev;
}

template <class T> T *TREE<T>::Get_Current()
{
 T *p;
 p=NULL;
 if (moving!=NULL)
  p=&(moving->Data);
 return(p);
}

template <class T> void TREE<T>::Set(T *Data)
{
 if (moving!=NULL)
  moving->Data=*Data;
}

template <class T> void TREE<T>::Set(T &Data)
{
 Set(&Data);
}

template <class T> void TREE<T>::GotoHead()
{
 moving=&Head;
}

#endif

