/****************************************/
/*  Virtual table                       */
/****************************************/
/* Start      : 12/9/99                 */
/* Program ID :                         */
/* Version    : 1.02                    */
/* End        :                         */
/* Last Update: 12/9/99                 */
/* Comments   : Using templates         */
/*                                      */
/****************************************/

/*
	3/7/2001	1.02:	Minor fix: Get_Next should return long * insted of int *
	21/12/99	1.01:	Added VTABLE::Rewind()
				Added VTABLE::Get_Next()
*/

#ifndef _VLIB_V_MEM_VTABLE_H
#define _VLIB_V_MEM_VTABLE_H

#include "dlist3.h"


/* Used by VTABLE to hold objects with index number */
template <class T> class VT_OBJ
{
 private:
 public:
  long index;
//  T *d;
   T d;
 private:
  void ddd(VT_OBJ<T> &d);
 public:
  VT_OBJ();
  ~VT_OBJ();
  VT_OBJ(VT_OBJ<T> &d);
  VT_OBJ<T> operator=(VT_OBJ<T> &d);
};
/*
 Virtual table... Create a table without size. First time we get a request for an element,
 this element is created. Thus table[1500000]=MPLAMPLA will only need one element allocated.
 This means that EVERY element referenced will be created.. EVEN IT IS READ ONLY!!!!
 (example: printf("%d\n",table_of_integeres[123456]); will create an element with index==123456)
*/
template <class T> class VTABLE
{
 private:
 public:
  DL_List< VT_OBJ<T> > d;
 private:
  void ddd(VTABLE &d);
  VT_OBJ<T> *GetN(long l);
//  void Add(long index, T *p);
  void Add(long index, T& p);
 public:
  VTABLE();
  ~VTABLE();
  VTABLE(VTABLE &d);
  VTABLE operator=(VTABLE &d);
  T &operator[](long l);
  T *Exist(long l);
  void Clear();
  void Del(long index); /* Delete an element (if it exist) */
  void Rewind();
  long *Get_Next();	// Get a pointer to the next index. This way the index number can be altered but THIS IS NOT A GOOD IDEA
  			// Someone should use T p; p=VTABLE::operator[X]; VTABLE::Del(X); VTABLE::operator[Y]=p; to change the index
  			// number of X to Y.
  			// Also: Inside a Rewind-Get_Next loop. Exist(), operator[]() and Del() should *NOT* be used, or the Get_Next()
  			//	 will not work as expected.
};



/*
 Linear table. If you access [15000], then the table
 will resize to be able to hold 15000 objects.

 It **WILL NOT** work with complex objects.
 (This means anything except int,long,void *,.. etc)
*/
template <class T> class VLTABLE
{
 private:
 public:
  T *d;
  size_t size; // Current size of d (X objects) (not in bytes)
 private:
  void ddd(VLTABLE<T> &d);
 public:
  VLTABLE(size_t init_size=0);
  ~VLTABLE();
  VLTABLE(VLTABLE<T> &d);
  VLTABLE<T> operator=(VLTABLE<T> &d);
  T &operator[](size_t pos);
  void setsize(size_t newsize);
};

#endif
