/****************************************/
/*  KEYTABLE class (header)             */
/****************************************/
/* Start      : 27/9/1998               */
/* Program ID :                         */
/* Version    : 1.02                    */
/* End        :                         */
/* Last Update: 3/7/2001                */
/* Comments   : Table with string keys  */
/*              (dynamic table)         */
/****************************************/

#ifndef _KEYTABLE_HPP
#define _KEYTABLE_HPP

#error DEPRICATED -- Use keytable2.h

#include "v/mem/dlist3.h"
#include "v/mem/longline.h"

/*
	v1.02 3/7/2001:		KEYTABLE::Add will now change the data of an element if it exist
	v1.01 6/1/2000:		when searching for an element, first check to see if the current element
				is the wanted one. This helps **A LOT** in the case decsribed bellow
				( I hope this will not create any bugs :)

	(30/12/99) WARNING!!!

	LONGLINE	*p;
	KEYTABLE<MYVAR> kt;
	MYVAR		*mv;

	kt.Rewind();
	while ((p=kt.Get_Next())!=NULL)
	{
		mv=kt[*p];	// This works.. BUT...
				// when using operator[], the Get_Next() position is lost.
				// In this case, there will be no problem, because it will
				// come back to kt[*p] (where it was).
				// This means, that this is the *ONLY* way to expect correct
				// results from a Rewind-Get_Next-operator[] combination
	}
*/

template <class T> struct KTOBJ // KEYTABLE Object
{
 long ID;
 LONGLINE str;
 T d;
 private:
  void vvv(KTOBJ& p)
  {
   ID=p.ID;
   str=p.str;
   d=p.d;
  }
 public:
  KTOBJ() {}
  KTOBJ(KTOBJ& p)
  {
   vvv(p);
  }
  KTOBJ operator=(KTOBJ &p)
  {
   vvv(p);
   return(*this);
  }
};

/*
 The data are copied.
 */

template <class T> class KEYTABLE
{
 private:
  long NextID;
  KTOBJ<T> *lastsearch;
 public:
  DL_List< KTOBJ<T> > d;
  long count;
 private:
  long Exist(const LONGLINE &s);
  KTOBJ<T> *GetKTO(const LONGLINE& s);
  void vvv(KEYTABLE& p);
//  void ClearTable();
 public:
  KEYTABLE();
  ~KEYTABLE();
  KEYTABLE(KEYTABLE<T> &p);
  KEYTABLE operator=(KEYTABLE<T>& p);
  long Add(const LONGLINE& str, T p);
  T *Get(const LONGLINE &str);
  void Del(const LONGLINE &str);
  T *operator[](const LONGLINE &str);
  T *operator[](const char *s);

  void Rewind();
  LONGLINE *Get_Next();
  void ClearTable();
};

#endif


/*
 Table (array) of objects, using a string as a key.
 */
