/****************************************/
/*					*/
/****************************************/
/* Start      : 15/07/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 15/07/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#include "random.h"

#if defined (_USE_DEV_RANDOM)
#	undef	_USE_DEV_URANDOM
#	undef	_USE_TIME_SEED
#elif defined (_USE_DEV_URANDOM)
#	undef	_USE_DEV_RANDOM
#	undef	_USE_TIME_SEED
#elif defined (_USE_TIME_SEED)
#	undef	_USE_DEV_RANDOM
#	undef	_USE_DEV_URANDOM
#else
#	define _USE_TIME_SEED
#endif

#if defined(_USE_DEV_RANDOM) || defined(_USE_DEV_URANDOM)
#include "stdio.h"
#else
#include "sys/time.h"
#endif

long	RANDOM::sporos;

RANDOM::RANDOM()
{
	sporos++;
	init_sporos();
#ifdef _USE_TIME_SEED
	do_time_seed();
#endif
}

RANDOM::~RANDOM()
{
}

RANDOM::RANDOM(RANDOM &d)
{
	ddd(d);
}

RANDOM RANDOM::operator=(RANDOM &d)
{
	ddd(d);
	return (*this);
}

void RANDOM::ddd(RANDOM &d)
{
}

RANDOM::operator signed long()
{
	signed long	l;

	get_random((char *)&l,sizeof(signed long));

	return(l);
}

RANDOM::operator signed int()
{
	signed int	l;

	get_random((char *)&l,sizeof(signed int));

	return(l);
}

RANDOM::operator signed short int()
{
	signed short int	l;

	get_random((char *)&l,sizeof(signed short int));

	return(l);
}

RANDOM::operator signed char()
{
	signed char	l;

	get_random((char *)&l,sizeof(signed char));

	return(l);
}

RANDOM::operator unsigned long()
{
	unsigned long	l;

	get_random((char *)&l,sizeof(unsigned long));

	return(l);
}

RANDOM::operator unsigned int()
{
	unsigned int	l;

	get_random((char *)&l,sizeof(unsigned int));

	return(l);
}

RANDOM::operator unsigned short int()
{
	unsigned short int	l;

	get_random((char *)&l,sizeof(unsigned short int));

	return(l);
}

RANDOM::operator unsigned char()
{
	unsigned char	l;

	get_random((char *)&l,sizeof(unsigned char));

	return(l);
}

char	*RANDOM::fill_buffer(char *buf, size_t buflen)
{
	get_random(buf,buflen);

	return(buf);
}

char	*RANDOM::fill_str(char *buf, size_t buflen)
{
	size_t	n;
	char	ch;

	buf[buflen-1]=0;
	for (n=0;n<buflen-1;n++)
	{
		do {
			get_random(&ch,1);
		} while(!isalnum(ch));
		buf[n]=ch;
	}

	return(buf);
}

void	RANDOM::get_random(char *buf, size_t buflen)
{
#ifdef _USE_TIME_SEED
	long	l;
	signed char	ch;
	int	n;
	size_t	m;

	for (n=0;n<(int)(buflen/sizeof(long));n++)
	{
		l=random()*random()*( random() & 1 ? 1 : -1);
		l^=sporos;
		*((long*)&buf[n*sizeof(long)]) = l;
	}
	m=n*sizeof(long);
 	for (n=0;n<(int)(buflen%sizeof(long));n++)
	{
		ch=(char)random();
		buf[m+n]=ch;
	}
#elif defined(_USE_DEV_RANDOM) || defined (_USE_DEV_URANDOM)
#ifdef _USE_DEV_RANDOM
#	define	RFILE	"/dev/random"
#else
#	define	RFILE	"/dev/urandom"
#endif
	FILE	*f;
	f=fopen(RFILE,"rb");
	if (f!=NULL)
	{
		fread(buf,buflen,1,f);
		fclose(f);
	}
#endif
}

void	RANDOM::do_time_seed()
{
#ifdef _USE_TIME_SEED
	struct timeval	tv;
	struct timezone	tz;
	int		n;

	gettimeofday(&tv,&tz);
	srandom(tv.tv_sec*tv.tv_usec+tv.tv_usec);

	for (n=0;n<(random()%30);n++)
		srandom(random());
#endif
}

void	RANDOM::init_sporos()
{
	int	n;
	char	buf[1024];
	long	l;
	double	d;
	char	*p;

#define	CHECK(x)	(x==0 ? 1 : x)

	p=(char *)malloc(1);
	l=(long)p;
	free(p);
	d=sporos*l+sporos-l;
	for (n=0;n<1024/4;n++)
		d=1.0*(1.0*(d+buf[n]-buf[n+1])*CHECK(buf[n+2]))/CHECK(buf[n+3]);

	while ( (d>0 ? d : -1*d) > LONG_MAX)
		d/=LONG_MAX;
	sporos=(long)d;
#undef CHECK
}

