/****************************************/
/*  Time queue.                         */
/****************************************/
/* Start      : 15/9/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 15/9/98                 */
/* Comments   : Store objects, that     */
/*   will be deleted afte expiration.   */
/****************************************/

#include "timequeue.h"
#include "v/mem/dlist3.cc"

template <class T> TQOBJ<T>::TQOBJ()
{
}

template <class T> TQOBJ<T>::TQOBJ(TQOBJ& p){ vvv(p);}

template <class T> TQOBJ<T> TQOBJ<T>::operator=(TQOBJ& p){ vvv(p); return(*this);}

template <class T> void TQOBJ<T>::vvv(TQOBJ& p)
{
 // d=new T(*p.d);
 d=p.d;
 tstart=p.tstart;
 tend=p.tend;
 ID=p.ID;
}


template <class T> TIMEQUEUE<T>::TIMEQUEUE()
{
 NextID=1;
}

template <class T> TIMEQUEUE<T>::~TIMEQUEUE()
{
 ClearList();
}

template <class T> void TIMEQUEUE<T>::Submit(T *d1, time_t ttl)
{
 cur=time(NULL);
 Smit(d1, cur, cur+ttl);
}

template <class T> void TIMEQUEUE<T>::SubmitUntil(T *d1, time_t tend)
{
 Smit(d1, time(NULL), tend);
}

template <class T> void TIMEQUEUE<T>::Smit(T *d1, time_t tstart, time_t tend)
{
 TQOBJ<T> *t;

 t=new TQOBJ<T>;
 t->d=d1;
 t->tstart=tstart;
 t->tend=tend;
 t->ID=NextID++;

 
 d.PushL(t);
}

template <class T> void TIMEQUEUE<T>::Expire(long ID)
{
 TQOBJ<T> *p,*q;
 T *p2;
 int OK=0;
 
 d.Rewind();

 while (((p=d.Get_Next())!=NULL) && (!OK)) // Search for the ID
  if (p->ID==ID) {OK=1; q=p;}

 if (OK) // If found
 {
  p2=q->d;
  delete p2;       // And free delete it
  d.RemoveItem(q); // Remove it from the list
 }
}

template <class T> void TIMEQUEUE<T>::CheckExpire()
{
 cur=time(NULL);
 SafeCheckExpire();
}

template <class T> void TIMEQUEUE<T>::SafeCheckExpire()
{
 TQOBJ<T> *p;
 long ID;

 d.Rewind();

 while ((p=d.Get_Next())!=NULL)
 {
  if (Expired(p)) // If expired
  {
   Expire(p->ID); // Expire it
   d.Rewind();    // And start over
  }
 }
}

template <class T> T *TIMEQUEUE<T>::Get_NextExpired()
{
 cur=time(NULL);
 return(SafeGet_NextExpired());
}

template <class T> T *TIMEQUEUE<T>::SafeGet_NextExpired()
{
 TQOBJ<T> *p;
 long ID;
 int n=0;
 T *p2;

 p=d.Get_Next();
 while ((!n) && (p!=NULL))
 {
  if (p!=NULL)
  {
   if (Expired(p))
    n=1;
  }
  if (!n)
   p=d.Get_Next();
 }
 (p==NULL ? p2=NULL : p2=p->d );
 return(p2);
}

template <class T> int TIMEQUEUE<T>::Expired(TQOBJ<T> *p)
{
 int n=0;
 if (p->tend<=cur) n=1;
 return(n);
}


template <class T> void TIMEQUEUE<T>::Rewind()
{
 cur=time(NULL);
 d.Rewind();
}

template <class T> void TIMEQUEUE<T>::SafeRewind()
{
 // d.Rewind();
 Rewind();
}

template <class T> T *TIMEQUEUE<T>::Get_Next()
{
 T *ret;
 TQOBJ<T> *p;

 p=d.Get_Next();
 if (p!=NULL) ret=p->d; else ret=NULL;
 return(ret);
}

template <class T> T *TIMEQUEUE<T>::Get_Prev()
{
 T *ret;
 TQOBJ<T> *p;

 p=d.Get_Prev();
 if (p!=NULL) ret=p->d; else ret=NULL;
 return(ret);
}

template <class T> void TIMEQUEUE<T>::ClearList()
{
 int lID;
 TQOBJ<T> *p;
 
 d.Rewind();
 lID=0;
 while ((p=d.Get_Next())!=NULL) // Get next
 {
  if (lID)      // If there was something before
   Expire(lID); // Expire it
  lID=p->ID;    // And set the current as previous
 }
 if (lID)
  Expire(lID);  // Now expire what's left (if any)
}

template <class T> time_t TIMEQUEUE<T>::GetNextExpireTime()
{
 TQOBJ<T> *p;
 time_t tnext;
 tnext=LASTTIME;

 d.Rewind();
 while ((p=d.Get_Next())!=NULL)
 {
  tnext=MIN(tnext,p->tend);
 }

 return(tnext);
}
