/****************************************/
/*  TIMEWAIT class                      */
/****************************************/
/* Start      : 20/9/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 27/9/98                 */
/* Comments   : Wait for some time...   */
/*                                      */
/****************************************/

#include "timewait.h"

TIMEWAIT::TIMEWAIT()
{
 SetAlarm(LASTTIME);
 OnOff=TIMEWAIT_ON;
}

TIMEWAIT::~TIMEWAIT()
{
}

void TIMEWAIT::SetAlarm(time_t t)
{
 Alarm=t;
}

void TIMEWAIT::NoAlarm()
{
// SetAlarm(0L);
 OnOff=TIMEWAIT_OFF;
}

time_t TIMEWAIT::CurTime()
{
 return(time(NULL));
}

void TIMEWAIT::SetAlarmAfter(time_t t)
{
 SetAlarm(CurTime()+t);
}

void TIMEWAIT::SetAlarmDate(int hour, int second, int minute, int month, int day, int year)
{
 SetAlarm(MkTime(hour,second,minute,month,day,year));
}

time_t TIMEWAIT::MkTime(int hour, int second, int minute, int month, int day, int year)
{
 struct tm t;
 time_t t2;
 
 t.tm_sec=second;
 t.tm_min=minute;
 t.tm_hour=hour;
 t.tm_mday=day;
 t.tm_mon=month;
 t.tm_year=year;

 t2=mktime(&t);

 return(t2);
}

int TIMEWAIT::IsAlarm()
{
 int n=0;
 
 if ((Alarm<=CurTime()) && (OnOff==TIMEWAIT_ON)) n=1;

 return(n);
}

void TIMEWAIT::Sleep()
{
 time_t t;
 
 do {
  t=GetSleepTime();
  if (t>0)
   sleep(t);
 } while (!IsAlarm());
}

time_t TIMEWAIT::GetSleepTime()
{
 time_t n,m;
 n=GetNextAlarm()-CurTime();
 m=( n>=0 ? n : 0L);
 m=(OnOff==TIMEWAIT_ON ? m : n);
 return(m);
}

time_t TIMEWAIT::GetNextAlarm()
{
 time_t n;
 if ((OnOff==TIMEWAIT_ON))
 {
  if (Alarm>CurTime())
   n=Alarm;
  else
   n=CurTime();
 }
 return(n);
}

void TIMEWAIT::vvv(TIMEWAIT& p)
{
 Alarm=p.Alarm;
 OnOff=p.OnOff;
}

TIMEWAIT::TIMEWAIT(TIMEWAIT& p)
{
 vvv(p);
}

TIMEWAIT TIMEWAIT::operator=(TIMEWAIT& p)
{
 vvv(p);
 return(*this);
}

