/****************************************/
/*  TIMEWAIT class (header)             */
/****************************************/
/* Start      : 20/9/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 27/9/98                 */
/* Comments   : Wait for some time...   */
/*                                      */
/****************************************/


#ifndef _VLIB_V_MISC_TIMEWAIT_H
#define _VLIB_V_MISC_TIMEWAIT_H

#include "time.h"
#include "unistd.h"
#include "limits.h"

#define LASTTIME LONG_MAX  // The maximum number for time_t

#define TIMEWAIT_ON 1
#define TIMEWAIT_OFF 0

class TIMEWAIT
{
 private:
 public:
  time_t Alarm;
  int OnOff;
 private:
  time_t CurTime();
  time_t MkTime(int hour, int second, int minute, int month, int day, int year);
  void vvv(TIMEWAIT& p);
 public:
  TIMEWAIT();
  ~TIMEWAIT();
  TIMEWAIT(TIMEWAIT& p);
  TIMEWAIT operator=(TIMEWAIT& p);
  void SetAlarm(time_t t);
  void NoAlarm();
  void SetAlarmAfter(time_t t); /* Set alarm after t seconds */
  void SetAlarmDate(int hour, int second, int minute, int month, int day, int year);
  int IsAlarm();
  void Sleep();
  time_t GetSleepTime();
  time_t GetNextAlarm();
};

#endif
