/****************************************/
/*  TIMEWAITLIST class                  */
/****************************************/
/* Start      : 27/9/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 27/9/98                 */
/* Comments   : Timers list             */
/*                                      */
/****************************************/

#include "timewaitlist.h"
#include "v/mem/dlist3.cc"

TWLOBJ::TWLOBJ() {}
TWLOBJ::TWLOBJ(TWLOBJ& p) { vvv(p); }
TWLOBJ TWLOBJ::operator=(TWLOBJ& p) { vvv(p); return(*this); }
void TWLOBJ::vvv(TWLOBJ& p)
{
 ID=p.ID;
 tw=p.tw;
}

TIMEWAITLIST::TIMEWAITLIST()
{
 NextID=1;
 AlarmN=0;
}

TIMEWAITLIST::~TIMEWAITLIST()
{
}

long TIMEWAITLIST::New()
{
 TWLOBJ two;
 
 two.ID=NextID++;
 two.tw=new(TIMEWAIT);
 d.PushL(two);
 AlarmN++;
 
 return(two.ID);
}

TIMEWAIT *TIMEWAITLIST::GetID(long ID)
{
 TWLOBJ *t;
 TIMEWAIT *tw;
 
 t=GetIDTWLOBJ(ID);
 
 tw=NULL;
 if (t!=NULL)
  tw=t->tw;
 
 return(tw);
}

int TIMEWAITLIST::Delete(long ID)
{
 int n=0;
 TWLOBJ *t;

 t=GetIDTWLOBJ(ID);
 if (t!=NULL)
 {
  n=1;
  d.RemoveItem(t);
  AlarmN--;
 }

 return(n);
}

TWLOBJ *TIMEWAITLIST::GetIDTWLOBJ(long ID)
{
 TWLOBJ *t;

 d.Rewind();
 while ((t=d.Get_Next())!=NULL)
  if (t->ID==ID) break;

 return(t);
}

time_t TIMEWAITLIST::GetNextAlarm()
{
 time_t t,t2;
 TWLOBJ *twl;

 t=LASTTIME;
 if (AlarmN)
 {
  d.Rewind();

  if ((twl=d.Get_Next())!=NULL)
  {
   t=twl->tw->GetNextAlarm();
  }

  while ((twl=d.Get_Next())!=NULL)
  {
   t2=twl->tw->GetNextAlarm();
   t=MIN(t,t2);
  }
 }
 
 return(t);
}

time_t TIMEWAITLIST::GetSleepTime()
{
 time_t t;
 TWLOBJ *twl;

 t=LASTTIME;
 if (AlarmN)
 {
  d.Rewind();

/*  if ((twl=d.Get_Next())!=NULL)
  {
   t=twl->tw->GetSleepTime();
  }*/

  while ((twl=d.Get_Next())!=NULL)
  {
   t=MIN(t,twl->tw->GetSleepTime());
  }
 }

 return(t);
}

long TIMEWAITLIST::IsAlarm()
{
 long n=0;
 TWLOBJ *twl;
 
 twl=NULL;
 
 if (AlarmN)
 {
  d.Rewind();
  if ((twl=d.Get_Next())!=NULL)
  {
    n=twl->tw->IsAlarm();
  }

  while ((twl!=NULL) && (!n))
  {
   //n=twl->tw->GetSleepTime();
   n=twl->tw->IsAlarm();
   if (!n)
    twl=d.Get_Next();
  }
 }
 
 if (twl!=NULL)
  n=twl->ID;
 
 return(n);
}

long TIMEWAITLIST::Sleep()
{
 time_t t;
 long l;
 
 if (AlarmN)
 {
  do {
   t=GetSleepTime();
   if (t>0)
    sleep(t);
  } while (!(l=IsAlarm()));
 }
 
 return(l);
}
