/****************************************/
/*  IPADDR class                        */
/****************************************/
/* Start      : 10/1/1999               */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 10/1/1999               */
/* Comments   : Convert IP addreses     */
/*             (string, long, etc...)   */
/****************************************/

#include "ipaddr.h"

IPADDR::IPADDR()
{
 ip=0;
 hostname[0]=0;
 ipaddr.s_addr=0;
}

IPADDR::~IPADDR()
{
}

IPADDR::IPADDR(IPADDR &p)
{
 ddd(p);
}

IPADDR IPADDR::operator=(IPADDR &p)
{
 ddd(p);
 return(*this);
}

void IPADDR::ddd(IPADDR &p)
{
 ip=p.ip;
 ipaddr.s_addr=p.ipaddr.s_addr;
 copy_hostname(p.hostname);
}

void IPADDR::convert(IPLONG ip)
{
 this->ip=ip;
 ipaddr.s_addr=htonl(ip);
 copy_hostname(inet_ntoa(ipaddr));
}

void IPADDR::convert(struct in_addr &inaddr)
{
 memcpy(&ipaddr,&inaddr,sizeof(ipaddr));
 this->ip=ntohl(ipaddr.s_addr);
 copy_hostname(inet_ntoa(ipaddr));
}

void IPADDR::convert(const char *hostname)
{
 copy_hostname(hostname);
 inet_aton(hostname,&ipaddr);
 ip=ntohl(ipaddr.s_addr);
}

void IPADDR::copy_hostname(const char *p)
{
 strncpy(hostname,p,_MAX_HOSTNAME);
 hostname[_MAX_HOSTNAME]=0;
}

long IPADDR::operator=(long ip)
{
 convert(ip);
 return(ip);
}

struct in_addr IPADDR::operator=(struct in_addr &inaddr)
{
 convert(inaddr);
 return(inaddr);
}

const char *IPADDR::operator=(const char *hostname)
{
 convert(hostname);
 return(hostname);
}

