/****************************************/
/*  SOCKETBASE class (header)           */
/****************************************/
/* Start      : 4/6/98                  */
/* Program ID :                         */
/* Version    : 1.01                    */
/* End        :                         */
/* Last Update: 11/7/2001               */
/* Comments   : Abstract class for use  */
/*              with SOCKETCONTROL      */
/****************************************/

#ifndef _VLIB_V_SOCKET_SBASE_H
#define _VLIB_V_SOCKET_SBASE_H

/*
	11/7/2001	v1.01:	Virtual destructor for SOCKETBASE
*/

/* Run return codes */
#define _SELECT_DONE 1001 // Done with the Main loop
#define _SELECT_DEREGISTER 1002 // Deregister this socket when done

class SOCKETBASE
{
 private:
 protected:
 public:
  long ID;
  int Registered;
  int fd;
  int WaitRead, WaitWrite, WaitExcept, WaitConnect;
 private:
 protected:
 public:
  SOCKETBASE();
  virtual ~SOCKETBASE();
  virtual int Run(void);	// This will run always
  virtual int RunRead(void);
  virtual int RunWrite(void);
  virtual int RunExcept(void);
  virtual int RunConnect(void);
};

#endif

