/****************************************/
/*  SOCKETCONTROL class (header)        */
/****************************************/
/* Start      : 4/6/98                  */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 4/6/98                  */
/* Comments   : Class for controlling   */
/*              sockets (for select)    */
/****************************************/


#ifndef _VLIB_V_SOCKET_SCONTROL_H
#define _VLIB_V_SOCKET_SCONTROL_H

#include "sys/time.h"
#include "sys/types.h"
#include "unistd.h"
#include "v/socket/sbase.h"
#include "v/mem/dlist3.h"
#include "v/minmax.h"
#include "string.h"

#ifndef _SOCKETCONTROL_MAXWAIT
#define _SOCKETCONTROL_MAXWAIT 0 // Seconds
#endif

#define _SOCKETCONTROL_LOOPMODE_ONELOOP 1   // Do one select and exit
#define _SOCKETCONTROL_LOOPMODE_MANYLOOPS 2 // Keep doing selects untill requested

class SOCKETCONTROL
{
 private:
	long	Next_ID;
 protected:
	DL_List<SOCKETBASE *>	socks;
	fd_set			fdr,fdw,fde;  // Read, Write, Exception
	int			Maxfd;  // highest-numbered descriptor in any of 3 sets
 public:
	int	MaxWait;
	int	DONE;
	int	LOOPMODE;
 private:
	void	CalcMaxfd	();
	void	ReSetfdsets	();
 protected:
	SOCKETBASE **FindID	(long ID);
	SOCKETBASE **Findfd	(int fd);
 public:
		SOCKETCONTROL	();
		~SOCKETCONTROL	();

	void	Main		(void);
	long	Register	(SOCKETBASE *p);
	void	Deregister	(long ID);
	void	Fdset		(SOCKETBASE *p);
};

#endif
